=== src/passes/CMakeLists.txt ===
add_custom_command(
  OUTPUT WasmIntrinsics.cpp
  COMMAND python ${PROJECT_SOURCE_DIR}/scripts/embedwast.py ${PROJECT_SOURCE_DIR}/src/passes/wasm-intrinsics.wast ${CMAKE_CURRENT_BINARY_DIR}/WasmIntrinsics.cpp
  DEPENDS ${PROJECT_SOURCE_DIR}/scripts/embedwast.py wasm-intrinsics.wast)

SET(passes_SOURCES
  pass.cpp
  CoalesceLocals.cpp
  CodePushing.cpp
  CodeFolding.cpp
  ConstHoisting.cpp
  DataFlowOpts.cpp
  DeadArgumentElimination.cpp
  DeadCodeElimination.cpp
  DuplicateFunctionElimination.cpp
  ExtractFunction.cpp
  Flatten.cpp
  FuncCastEmulation.cpp
  I64ToI32Lowering.cpp
  Inlining.cpp
  InstrumentLocals.cpp
  InstrumentMemory.cpp
  LegalizeJSInterface.cpp
  LocalCSE.cpp
  LogExecution.cpp
  LoopInvariantCodeMotion.cpp
  MemoryPacking.cpp
  MergeBlocks.cpp
  MergeLocals.cpp
  Metrics.cpp
  MinifyImportsAndExports.cpp
  NameList.cpp
  NoExitRuntime.cpp
  OptimizeInstructions.cpp
  PickLoadSigns.cpp
  PostEmscripten.cpp
  Precompute.cpp
  Print.cpp
  PrintCallGraph.cpp
  StackIR.cpp
  Strip.cpp
  RedundantSetElimination.cpp
  RelooperJumpThreading.cpp
  ReReloop.cpp
  RemoveImports.cpp
  RemoveMemory.cpp
  RemoveNonJSOps.cpp
  RemoveUnusedBrs.cpp
  RemoveUnusedNames.cpp
  RemoveUnusedModuleElements.cpp
  ReorderLocals.cpp
  ReorderFunctions.cpp
  TrapMode.cpp
  SafeHeap.cpp
  SimplifyLocals.cpp
  Souperify.cpp
  SpillPointers.cpp
  SSAify.cpp
  Untee.cpp
  Vacuum.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/WasmIntrinsics.cpp
)
ADD_LIBRARY(passes STATIC ${passes_SOURCES})
