=== debian/changelog ===
binaryen (87-1) unstable; urgency=medium

  * New upstream version 87.
  * Declare compliance with Debian Policy 4.4.0.
  * Use debhelper-compat = 12.

 -- Markus Koschany <apo@debian.org>  Wed, 17 Jul 2019 21:37:56 +0200
