=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 12),
+ debhelper-compat (= 12),
  python
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/WebAssembly/binaryen
 Vcs-Git: https://salsa.debian.org/debian/binaryen.git
 Vcs-Browser: https://salsa.debian.org/debian/binaryen
