=== src/passes/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
   DeadArgumentElimination.cpp
   DeadCodeElimination.cpp
   Directize.cpp
+  DuplicateImportElimination.cpp
   DuplicateFunctionElimination.cpp
   ExtractFunction.cpp
   Flatten.cpp
