=== debian/changelog ===
binaryen (89-1) unstable; urgency=medium

  * New upstream version 89.
    - Fix CVE-2019-15758:
      Missing validation rules in asmjs/asmangle.cpp can lead to an Assertion
      Failure at wasm/wasm.cpp in wasm::asmangle. A crafted input can cause
      denial-of-service, as demonstrated by wasm2js.
    - Fix CVE-2019-15759:
      Two visitors in ir/ExpressionManipulator.cpp can lead to a NULL pointer
      dereference in wasm::LocalSet::finalize in wasm/wasm.cpp. A crafted input
      can cause segmentation faults, leading to denial-of-service, as
      demonstrated by wasm2js.
      Thanks to Moritz Muehlenhoff for the report. (Closes: #936024)
  * d/control: Build with python3. Add python3.patch to avoid a FTBFS.

 -- Markus Koschany <apo@debian.org>  Thu, 29 Aug 2019 16:04:13 +0200
