=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 12),
- python
+ python3
 Standards-Version: 4.4.0
 Homepage: https://github.com/WebAssembly/binaryen
 Vcs-Git: https://salsa.debian.org/debian/binaryen.git
