=== debian/changelog ===
binaryen (90-1) unstable; urgency=medium

  * New upstream version 90.
  * Update debian/copyright and mention the LLVM exception.
  * Declare compliance with Debian Policy 4.4.1.
  * Add BINARYEN_VERSION_INFO.patch to avoid a build-dependency on Git.

 -- Markus Koschany <apo@debian.org>  Tue, 31 Dec 2019 15:43:52 +0100
