## binaryen 91

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-project(binaryen C CXX)
 cmake_minimum_required(VERSION 3.1.3)
+project(binaryen LANGUAGES C CXX VERSION 91)
 include(GNUInstallDirs)
 
 if(NOT CMAKE_BUILD_TYPE)
@@ -11,20 +11,23 @@
 # more useful error reports from users.
 option(BYN_ENABLE_ASSERTIONS "Enable assertions" ON)
 
-find_package(Git QUIET REQUIRED)
-execute_process(COMMAND
-             "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
-         RESULT_VARIABLE
-             GIT_HASH_RESULT
-         OUTPUT_VARIABLE
-             GIT_HASH
-         OUTPUT_STRIP_TRAILING_WHITESPACE)
-if(${GIT_HASH_RESULT})
-  message(WARNING "Error running git describe to determine version")
-  set(BINARYEN_VERSION_INFO "(unable to determine version)")
-else()
-  set(BINARYEN_VERSION_INFO "${GIT_HASH}")
-endif()
+# For git users, attempt to generate a more useful version string
+if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
+  find_package(Git QUIET REQUIRED)
+  execute_process(COMMAND
+               "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags --match version_*
+           RESULT_VARIABLE
+               GIT_VERSION_RESULT
+           OUTPUT_VARIABLE
+               GIT_VERSION
+           OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if(${GIT_VERSION_RESULT})
+    message(WARNING "Error running git describe to determine version")
+  else()
+    set(PROJECT_VERSION "${PROJECT_VERSION} (${GIT_VERSION})")
+  endif()
+endif()
+
 configure_file(config.h.in config.h)
 
 # Support functionality.
@@ -182,7 +185,7 @@
   if(WIN32)
     add_compile_flag("-D_GNU_SOURCE")
     add_link_flag("-Wl,--stack,8388608")
-  else()
+  elseif(NOT EMSCRIPTEN)
     add_compile_flag("-fPIC")
   endif()
   add_debug_compile_flag("-O0")
@@ -320,5 +323,3 @@
 set(wasm-emscripten-finalize_SOURCES
   src/tools/wasm-emscripten-finalize.cpp
 )
-add_executable(wasm-emscripten-finalize ${wasm-emscripten-finalize_SOURCES} ${binaryen_objs})
-target_link_libraries(wasm-emscripten-finalize ${CMAKE_THREAD_LIBS_INIT})
