=== src/cfg/CMakeLists.txt ===
set(cfg_SOURCES
  Relooper.cpp
)
add_library(cfg OBJECT ${cfg_SOURCES})
