=== debian/changelog ===
binaryen (91-1) unstable; urgency=medium

  * New upstream version 91.
  * Drop all patches. Fixed upstream.
  * Declare compliance with Debian Policy 4.5.0.

 -- Markus Koschany <apo@debian.org>  Wed, 26 Feb 2020 21:58:27 +0100
