=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  cmake,
  debhelper-compat (= 12),
  python3
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/WebAssembly/binaryen
 Vcs-Git: https://salsa.debian.org/debian/binaryen.git
 Vcs-Browser: https://salsa.debian.org/debian/binaryen
