=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/version_?(\d\S+)\.tar\.gz/binaryen-$1\.tar\.gz/ \
  https://github.com/WebAssembly/binaryen/tags .*/version_?(\d\S+)\.tar\.gz
